angular.module('starter.controllers', ['ngCordova'])

.controller('DashCtrl', function($scope, faPage, $http) {

  var paging;

  faPage.lista().then(function(dados){
		$scope.posts = dados.data;
    paging = dados.paging;
	});

  $scope.pageNext = function()
  {
      $http.get(decodeURI(paging.next))
      .success(function(dados){
          if(dados.data.length > 0){
            $scope.posts = $scope.posts.concat(dados.data);
            paging.next = dados.paging.next;
          }
      });
  };

  $scope.pagePrevious = function()
  {
      $http.get(decodeURI(paging.previous))
      .success(function(dados){
          if(dados.data.length > 0){
            $scope.posts = dados.data.concat($scope.posts);
            paging.previous = dados.paging.previous;
          }
      }).finally(function() {
       // Stop the ion-refresher from spinning
       $scope.$broadcast('scroll.refreshComplete');
     });
  };

  $scope.BRdate = function(dateTime)
  {
      var months = ['Janeiro','Fevereiro','Março','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'];
      var date = dateTime.substr(0,10).split('-'), hora = dateTime.substr(11,5);
      return date[2]+' de '+ months[date[1] - 1]+ ' às ' +hora;
  };

  $scope.iframe = function(url)
  {
      return 'https://www.facebook.com/plugins/video.php?href='+url.replace(/\"/g, "")+'&show_text=0';
  };

  $scope.count = function(obj)
  {
      return obj ? obj.data.length : 0;
  }

})

.controller('MidiaCtrl', function($scope, Midia, $ionicLoading) {
  $scope.readCategorias = function(){
    Midia.readCategorias().then(function(resultados){
      if(resultados.length === 0){
        $ionicLoading.show({
          content: 'Loading',
          animation: 'fade-in',
          showBackdrop: true,
          maxWidth: 200,
          showDelay: 0
        });

        Midia.getExternal().then(function(response)
        {
            var len = response.data.data.length, i, midia, query;

            for (i = 0; i < len; i++)
            {
                midia = response.data.data[i];
                query = 'INSERT INTO midias (Id, Tipo, Categoria, Nome, Descricao, NomeArquivo, Link) VALUES ("'+midia.Id+'", "'+midia.Tipo+'", "'+midia.Categoria+'", "'+midia.Nome+'", "'+midia.Descricao+'", "'+midia.NomeArquivo+'", "'+midia.Link+'")'
                Midia.promessaQuery(query,
                function(deferido)
                {
                  return function (tx, results){
                    deferido.resolve(true);
                  }
                }, function(deferido){});
            }
            $ionicLoading.hide().then(function(){
              $scope.readCategorias();
            });
          });
      }
      else
        $scope.categorias = resultados;
    });
  }

  $scope.updateMidias = function(){
    Midia.update().then(function(response){
      var len = response.data.data.length, i, midia, query;
      console.log(response.data);
      if(len > 0){
        for (i = 0; i < len; i++)
        {
            midia = response.data.data[i];
            query = 'INSERT INTO midias (Id, Tipo, Categoria, Nome, Descricao, NomeArquivo, Link) VALUES ("'+midia.Id+'", "'+midia.Tipo+'", "'+midia.Categoria+'", "'+midia.Nome+'", "'+midia.Descricao+'", "'+midia.NomeArquivo+'", "'+midia.Link+'")'
            Midia.promessaQuery(query,
            function(deferido)
            {
              return function (tx, results){
                deferido.resolve(true);
              }
            }, function(deferido){});
        }
        $scope.readCategorias();
      }
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  $scope.readCategorias();
})

.controller('MidiaForCategoriaCtrl', function($scope, $stateParams, Midia) {
  $scope.categoria = $stateParams.categoria;
  Midia.readByCategoria($stateParams.categoria).then(function(resultados){
    $scope.midias = resultados;
  });
})

.controller('MidiaDetailsCtrl', function($scope, $stateParams, Midia, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout) {

  Midia.readById($stateParams.midiaId).then(function(resultado){
    $scope.midia = resultado;

    var path = 'camporiMN/midias/', result;
    $scope.path = cordova.file.externalRootDirectory+path+resultado.NomeArquivo;
    $cordovaFile.checkFile(cordova.file.externalRootDirectory, path+resultado.NomeArquivo)
    .then(function (success){
      $scope.downloaded = true;
    }, function(error){
      $scope.downloaded = false;
    });

  });

  $scope.download = function(NomeArquivo, Link)
  {
    var path = 'camporiMN/midias/';

    $cordovaFileTransfer.download(Link, cordova.file.externalRootDirectory+path+NomeArquivo, {}, true)
    .then(function(result) {
      $scope.path = cordova.file.externalRootDirectory+path+NomeArquivo;
      $scope.downloaded = true;
      $scope.downloading = false;
      $scope.downloadProgress = 0;
    }, function(err) {
      alert('Error ao fazer o download. Tente novamente');
      $scope.downloading = false;
      $scope.downloaded = false;
      $scope.downloadProgress = 0;
    }, function (progress) {
      $scope.downloading = true;
      $scope.downloaded = true;
      $timeout(function () {
        $scope.downloadProgress = (progress.loaded / progress.total) * 100;
      });
    });
  };

  $scope.playerVideo = function(path, NomeArquivo)
  {
      if($scope.downloading)
        return true;

      var caminho = 'camporiMN/midias/';
      $cordovaFile.checkFile(cordova.file.externalRootDirectory, caminho+NomeArquivo).then(
        function(success){
          $cordovaFileOpener2.open(path, 'video/mp4')
          .then(function(success){}, function(error){
            alert('Error ao abrir arquivo');
          });
        },
        function(error){
          alert('Primeiro faça o download do arquivo.');
        }
      );
  }
})

.controller('EquipeCtrl', function($scope, $rootScope, Equipe) {
  $rootScope.show = '';
})

.controller('EquipeAllCtrl', function($scope, $rootScope, Equipe) {
  Equipe.get().then(function(response){
    $scope.equipe = response.data;
  });
})

.controller('EquipeDetailsCtrl', function($scope, $rootScope, $stateParams, Equipe, Clubes){
  Equipe.get().then(function(response){
    $scope.membro = response.data[$stateParams.id];
  });

  Clubes.getByRegiao().then(function(response){
    $scope.clubes = response.data[$stateParams.id];

    if($scope.clubes.length > 0){
      $scope.hasClubes = true;
      $scope.bg = '#3060b4';
    }
    else{
      $scope.bg = '#febc24';
      $scope.hasClubes = false;
    }
  });
})

.controller('ConvidadosAllCtrl', function($scope, Convidados) {
  Convidados.get().then(function(response){
    $scope.convidados = response.data;
  });
})

.controller('ConvidadoDetailsCtrl', function($scope, $stateParams, Convidados){
  Convidados.get().then(function(response){
    $scope.convidado = response.data[$stateParams.id];
  });
})

.controller('BoletinsCtrl', function($scope, boletins, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout) {
  $scope.downloadProgress = 0;
  $scope.readArchive = function(boletim)
  {
    var path = 'camporiMN/boletins/';
    $cordovaFile.checkFile(cordova.file.externalRootDirectory, path+boletim.NomeArquivo)
    .then(function (success) {
      // success
      $cordovaFileOpener2.open(cordova.file.externalRootDirectory+path+boletim.NomeArquivo,'application/pdf')
      .then(function(){}, function(){});
    }, function (error) {
      // error
      $cordovaFileTransfer.download(boletim.Link, cordova.file.externalRootDirectory+path+boletim.NomeArquivo, {}, true)
      .then(function(result) {
        boletim.downloading = false;
        $cordovaFileOpener2.open(cordova.file.externalRootDirectory+path+boletim.NomeArquivo,'application/pdf')
        .then(function(){}, function(){});
      }, function(err) {
        alert('Error ao fazer o download. Tente novamente');
        boletim.downloading = false;
        boletim.downloadProgress = 0;
      }, function (progress) {
        boletim.downloading = true;
        $timeout(function () {
          boletim.downloadProgress = (progress.loaded / progress.total) * 100;
        });
      });
    });
  }
  $scope.readBoletins = function()
  {
    boletins.read().then(function(resultados){
      if(resultados.length === 0){
        boletins.lista().then(function(dados){
      		$scope.boletins = dados.data;
      	});
        boletins.getExternal();
      }
      else
        $scope.boletins = resultados;

      $scope.updateBoletins();
    });
  }

  $scope.updateBoletins = function(){
    boletins.update().then(function(response){
      var len = response.data.data.length, i, boletim, query;
      console.log(response.data);
      if(len > 0){
        for (i = 0; i < len; i++)
        {
          boletim = response.data.data[i];
          query = 'INSERT INTO boletins (Id, Nome, Descricao, NomeArquivo, Link, Ext) VALUES ("'+boletim.Id+'", "'+boletim.Nome+'", "'+boletim.Descricao+'", "'+boletim.NomeArquivo+'", "'+boletim.Link+'", "'+boletim.Ext+'")'
          boletins.promessaQuery(query,
          function(deferido)
          {
            return function (tx, results){
              deferido.resolve(true);
            }
          }, function(deferido){});
        }
        $scope.boletins = response.data.data.concat($scope.boletins);
      }
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  $scope.readBoletins();
});
