angular.module('starter.services', [])

.factory('install', function($http, $rootScope, $q, $cordovaFileTransfer, $cordovaFile){
  var db;

  function createDB(){
      try {
        db = window.sqlitePlugin.openDatabase({name: 'camporiMN.db', location: 'default'}, function(db){
          db.transaction(function(tx) {
            db.transaction(function (tx) {
              tx.executeSql('CREATE TABLE IF NOT EXISTS boletins (Id INTEGER PRIMARY KEY ASC, Nome varchar(250) NOT NULL, Descricao TEXT NOT NULL, NomeArquivo TEXT NOT NULL, Link TEXT NOT NULL, Ext varchar(10) NOT NULL)');
              tx.executeSql('CREATE TABLE IF NOT EXISTS midias (Id INTEGER PRIMARY KEY ASC, Tipo varchar(250) NOT NULL, Categoria varchar(250) NOT NULL, Nome varchar(250) NOT NULL, Descricao TEXT NOT NULL, NomeArquivo TEXT NOT NULL, Link TEXT NOT NULL, Ext varchar(10) NULL)');
            });
          }, function(err) {
            alert('Open database ERROR: ' + JSON.stringify(err));
          });
        });
        /*db = openDatabase('camporiMN', '1.0', 'db app camporiMN', 2 * 1024 * 1024);
        db.transaction(function (tx) {
          tx.executeSql('CREATE TABLE IF NOT EXISTS boletins (Id INTEGER PRIMARY KEY ASC, Nome varchar(250) NOT NULL, Descricao TEXT NOT NULL, NomeArquivo TEXT NOT NULL, Link TEXT NOT NULL, Ext varchar(10) NOT NULL)');
          tx.executeSql('CREATE TABLE IF NOT EXISTS midias (Id INTEGER PRIMARY KEY ASC, Tipo varchar(250) NOT NULL, Categoria varchar(250) NOT NULL, Nome varchar(250) NOT NULL, Descricao TEXT NOT NULL, NomeArquivo TEXT NOT NULL, Link TEXT NOT NULL, Ext varchar(10) NULL)');
        });*/
      }catch (err){
        alert('Erro: ' + erro);
      }
      console.log('Banco de dados criado/aberto');
  }

  function initDir()
  {
    $cordovaFile.checkDir(cordova.file.externalRootDirectory, "camporiMN")
      .then(function (success) {

      }, function (error) {
        //Create directory camporiMN
        $cordovaFile.createDir(cordova.file.externalRootDirectory, "camporiMN", false)
        .then(function (success) {
          //Create directory boletins
          $cordovaFile.checkDir(cordova.file.externalRootDirectory, "camporiMN/boletins")
          .then(function(success){}, function(error){
            $cordovaFile.createDir(cordova.file.externalRootDirectory, "camporiMN/boletins", false)
            .then(function(success){
              //Create directory
            }, function(error){});
          });
          //Create directory midias
          $cordovaFile.checkDir(cordova.file.externalRootDirectory, "camporiMN/midias")
          .then(function(success){}, function(error){
            $cordovaFile.createDir(cordova.file.externalRootDirectory, "camporiMN/midias", false)
            .then(function(success){
              //Create directory
            }, function(error){});
          });
        }, function (error) {
          alert('error create directory');
        });
      });
  }

  $rootScope.promessaQuery = function(query, sucessCallback, errorCallback){
        var deferido = $q.defer();
        //var db = openDatabase('camporiMN', '1.0', 'db app camporiMN', 2 * 1024 * 1024);
        var db = window.sqlitePlugin.openDatabase({name: 'camporiMN.db', location: 'default'});
        db.transaction(function (tx) {
          tx.executeSql(query, [], sucessCallback(deferido),
            errorCallback(deferido));
        });
        return deferido.promise;
  }

  return{
    createDB: function()
    {
      return createDB();
    },
    initDir: function()
    {
      return initDir();
    }
  };

})

.factory('Midia', function($http, $q, $ionicLoading){

  var url = "https://api.campori.divmaster.com.br/v01/get/midias";

  function promessaQuery(query, sucessCallback, errorCallback){
        var deferido = $q.defer();
        //var db = openDatabase('camporiMN', '1.0', 'db app camporiMN', 2 * 1024 * 1024);
        var db = window.sqlitePlugin.openDatabase({name: 'camporiMN.db', location: 'default'});
        db.transaction(function (tx) {
          tx.executeSql(query, [], sucessCallback(deferido),
            errorCallback(deferido));
        });
        return deferido.promise;
  }

  function callBackSucesso(deferido)
  {
    return function (tx, results){
      var len = results.rows.length, i;
      var resultados = [];
      for (i = 0; i < len; i++) {
        var midia = {
          Id: results.rows.item(i).Id,
          Tipo: results.rows.item(i).Tipo,
          Categoria: results.rows.item(i).Categoria,
          Nome: results.rows.item(i).Nome,
          Descricao: results.rows.item(i).Descricao,
          Link: results.rows.item(i).Link,
          NomeArquivo: results.rows.item(i).NomeArquivo,
          Ext: results.rows.item(i).Ext,
        }
        resultados.push(midia);
      }
      deferido.resolve(resultados);
    };
  }
  //Callback de success para o readCategorias
  function prepareCategorias(deferido)
  {
    return function (tx, results){
      var len = results.rows.length, i;
      var resultados = [];
      for (i = 0; i < len; i++) {
        var categoria = {
          Categoria: results.rows.item(i).Categoria
        }
        resultados.push(categoria);
      }
      deferido.resolve(resultados);
    };
  }

  function callBackErro(deferido){
      return function (tx, results){
          var resultados = false;
          console.log(results);
          deferido.resolve(resultados);
      }
  }
  function getExternal()
  {
    return $http.get(url);
  }

  function readCategorias()
  {
    return promessaQuery('SELECT DISTINCT Categoria FROM midias', prepareCategorias, callBackErro);
  }

  function readByCategoria(categoria)
  {
    return promessaQuery('SELECT * FROM midias WHERE Categoria = "'+categoria+'"', callBackSucesso, callBackErro);
  }

  function readById(id)
  {
    return promessaQuery('SELECT * FROM midias WHERE Id = "'+id+'"', function(deferido){
      return function (tx, results){
        var len = results.rows.length;
        var midia = {
          Id: results.rows.item(0).Id,
          Tipo: results.rows.item(0).Tipo,
          Categoria: results.rows.item(0).Categoria,
          Nome: results.rows.item(0).Nome,
          Descricao: results.rows.item(0).Descricao,
          Link: results.rows.item(0).Link,
          NomeArquivo: results.rows.item(0).NomeArquivo,
          Ext: results.rows.item(0).Ext,
        }
        deferido.resolve(midia);
      };
    }, callBackErro);
  }

  function getLastMidia()
  {
    return promessaQuery('SELECT Id FROM midias ORDER BY Id DESC LIMIT 1', function(deferido){
      return function (tx, results){
        var midia = {
          Id: results.rows.item(0).Id
        }
        deferido.resolve(midia);
      };
    }, callBackErro);
  }

  return {
    getExternal: function(){
      return getExternal();
    },
    readCategorias: function(){
      return readCategorias();
    },
    readByCategoria: function(categoria){
      return readByCategoria(categoria);
    },
    readById: function(id){
      return readById(id);
    },
    promessaQuery: function(query, success, error)
    {
      return promessaQuery(query, success, error);
    },
    lista: function(){
      return $http.get(url).then(function(response)
      {
        return response.data;
      });
    },
    update: function(){
      return getLastMidia().then(function(resultado){
        var urlUpdate = 'https://api.campori.divmaster.com.br/v01/get/updateMidias/'+resultado.Id;
        console.log(urlUpdate);
        return $http.get(urlUpdate);
      });
    }
  }
})
.factory('Equipe', function($http, $q){
  return {
    get: function(){
      return $http.get('js/data/equipe.json');
    }
  };
})
.factory('Clubes', function($http, $q){
  return {
    getByRegiao: function(){
      return $http.get('js/data/clubes.json');
    }
  };
})
.factory('Convidados', function($http, $q){
  return {
    get: function(){
      return $http.get('js/data/convidados.json');
    }
  };
})

.factory('faPage', function($http, $q){
	var url = "https://graph.facebook.com/v2.7/605318602977183/posts?fields=message%2Cpicture%2Cfull_picture%2Clink%2Ctype%2Ccreated_time%2Cicon%2Ccomments.limit(1000)%7Bid%7D%2Clikes.limit(1000)%7Bid%7D&limit=10&access_token=1782693551977802%7CCMGK4_g27iDGs1YqGYnGu9G-XYo";

	return {
		lista: function(){
			return $http.get(url).then(function(response)
			{
				return response.data;
			});
		}
	}
})

.factory('boletins', function($http, $rootScope, $q){
  var url = "https://api.campori.divmaster.com.br/v01/get/boletins";

  function promessaQuery(query, sucessCallback, errorCallback){
        var deferido = $q.defer();
        //var db = openDatabase('camporiMN', '1.0', 'db app camporiMN', 2 * 1024 * 1024);
        var db = window.sqlitePlugin.openDatabase({name: 'camporiMN.db', location: 'default'});
        db.transaction(function (tx) {
          tx.executeSql(query, [], sucessCallback(deferido),
            errorCallback(deferido));
        });
        return deferido.promise;
  }

  function callBackSucesso(deferido){
    return function (tx, results){
        var len = results.rows.length, i;
        var resultados = [];
        for (i = 0; i < len; i++) {
            var boletim = {
                Id : results.rows.item(i).Id,
                Nome: results.rows.item(i).Nome,
                Descricao: results.rows.item(i).Descricao,
                Link: results.rows.item(i).Link,
                NomeArquivo: results.rows.item(i).NomeArquivo
            }
            resultados.push(boletim);
        }
        deferido.resolve(resultados);
      };
  }

  function callBackErro(deferido){
      return function (tx, results){
          var resultados = false;
          console.log(results);
          deferido.resolve(resultados);
      }
  }
  function getExternal()
  {
    var data;
    $http.get(url).then(function(response)
    {
        var len = response.data.data.length, i, boletim, query;

        for (i = 0; i < len; i++)
        {
            boletim = response.data.data[i];
            query = 'INSERT INTO boletins (Id, Nome, Descricao, NomeArquivo, Link, Ext) VALUES ("'+boletim.Id+'", "'+boletim.Nome+'", "'+boletim.Descricao+'", "'+boletim.NomeArquivo+'", "'+boletim.Link+'", "'+boletim.Ext+'")'
            promessaQuery(query,
            function(deferido)
            {
              return function (tx, results){
                deferido.resolve(true);
              }
            }, callBackErro);
        }
        data = response.data.data;
      });
      console.log(data);
      return data;
    }

  function read()
  {
    return promessaQuery('SELECT * FROM boletins ORDER BY Id DESC', callBackSucesso, callBackErro);
  }

  function getLastBoletim()
  {
    return promessaQuery('SELECT Id FROM boletins ORDER BY Id DESC LIMIT 1', function(deferido){
      return function (tx, results){
        var boletim = {
          Id: results.rows.item(0).Id
        }
        deferido.resolve(boletim);
      };
    }, callBackErro);
  }

  return {
    promessaQuery: function(query, success, error)
    {
      return promessaQuery(query, success, error);
    },
    getExternal: function(){
      return getExternal();
    },
    read: function(){
      return read();
    },
    lista: function(){
			return $http.get(url).then(function(response)
			{
				return response.data;
			});
		},
    update: function(){
      return getLastBoletim().then(function(resultado){
        var urlUpdate = 'https://api.campori.divmaster.com.br/v01/get/updateBoletins/'+resultado.Id;
        return $http.get(urlUpdate);
      });
    }
  }
});
